import { Component, OnInit, ViewChild } from '@angular/core';
import { STComponent, STColumn, STChange } from '@delon/abc/st';
import { SFComponent, SFSchema } from '@delon/form';
import { NzModalService } from 'ng-zorro-antd/modal';
import { SystemService } from '../../services/system.service';
import { CartConfigActionModalComponent } from './cart-config-action-modal/cart-config-action-modal.component';

@Component({
  selector: 'app-cart-config',
  templateUrl: './cart-config.component.html',
  styleUrls: ['./cart-config.component.less']
})
export class CartConfigComponent implements OnInit {
  @ViewChild('st', { static: true })
  st!: STComponent;
  @ViewChild('sf', { static: false })
  sf!: SFComponent;
  tabs = [
    {
      name: '车型配置',
      type: 1,
      isActived: false
    },
    {
      name: '车长配置',
      type: 2,
      isActived: false
    },
    {
      name: '禁限物品名单',
      type: 3,
      isActived: false
    }
  ];
  tabType = 1;
  url = `/rule?_allow_anonymous=true`;

  searchSchema: SFSchema = {
    properties: {
      tabType: {
        type: 'number',
        ui: {
          hidden: true
        }
      },
      params1: {
        title: '车型',
        type: 'string',
        ui: {
          placeholder: '请输入',
          visibleIf: {
            tabType: (value: number) => this.tabType === 1
          }
        }
      },
      params2: {
        title: '车长',
        type: 'string',
        ui: {
          placeholder: '请输入',
          visibleIf: {
            tabType: (value: number) => this.tabType === 2
          }
        }
      },
      params3: {
        title: '物品名称',
        type: 'string',
        ui: {
          placeholder: '请输入',
          visibleIf: {
            tabType: (value: number) => this.tabType === 3
          }
        }
      }
    }
  };

  columns: STColumn[] = [
    { title: '车型', index: 'no', iif: () => this.tabType === 1 },
    { title: '车长', index: 'no', iif: () => this.tabType === 2 },
    { title: '物品名称', index: 'no', iif: () => this.tabType === 3 },
    {
      title: '启用状态',
      className: 'text-center',
      index: 'status',
      type: 'badge',
      badge: {
        0: { text: '启用', color: 'success' },
        2: { text: '禁用', color: 'error' },
        3: { text: '禁用', color: 'error' },
        1: { text: '禁用', color: 'error' }
      }
    },
    {
      title: '创建时间',
      index: 'updatedAt',
      type: 'date'
    },
    {
      title: '操作',
      buttons: [
        {
          text: '编辑',
          click: item => this.configAction(item)
        },
        {
          text: '删除',
          click: item => this.deleteAction(item)
        }
      ]
    }
  ];

  selectedRows: any[] = [];

  reqParams = { pageIndex: 1, pageSize: 10 };

  constructor(public service: SystemService, private nzModalService: NzModalService) {}

  ngOnInit(): void {}

  // 切换Tab
  changeTab(item: any) {
    this.tabType = item.type;
    this.sf?.setValue('/tabType', item.type);
    this.sf?.reset();
    setTimeout(() => {
      this.tabs.forEach(i => (i.isActived = false));
      item.isActived = !item.isActived;
      this.st.load(1);
      this.st.resetColumns();
    }, 500);
  }

  stChange(e: STChange): void {
    switch (e.type) {
      case 'checkbox':
        this.selectedRows = e.checkbox!;
        break;
      case 'filter':
        this.st.load();
        break;
    }
  }

  configAction(item?: any) {
    const modal = this.nzModalService.create({
      nzContent: CartConfigActionModalComponent,
      nzComponentParams: item
        ? { i: { ...item, roleId: 1, phone1: '车辆审核', phone2: '车辆审核', phone3: '车辆审核' }, configType: this.tabType }
        : { i: { id: 0 }, configType: this.tabType },
      nzFooter: null
    });
    modal.afterClose.subscribe(res => {
      this.st.load();
    });
  }

  deleteAction(item?: any) {
    this.nzModalService.error({
      nzTitle: '确认删除？',
      nzClosable: false,
      nzCancelText: '取消',
      nzOnOk: () => {}
    });
  }
  /**
   * 重置表单
   */
  resetSF() {
    this.sf.reset();
  }
}
